(function() {
    
    // a bit.ly v3 API library
    // uses JSONP for cross site scripting
    var host = "http://api.bit.ly", ssl_host = "",
        urls = {
            'shorten' : '/v3/shorten',
            'expand' : '/v3/expand',
            'info' : '/v3/info',
            'clicks' : '/v3/clicks',
            'lookup' : '/v3/lookup'
        };
        
        
    var bitlyAPI = function( login, apiKey ) {
        return new bitlyAPI.fn.init( login, apiKey );
    }
    
    window.bitlyAPI = bitlyAPI;
    
    bitlyAPI.fn = bitlyAPI.prototype = {
        
        init : function(  login, apiKey ) {
            this.bit_request.login = login;
            this.bit_request.apiKey = apiKey;
            this.bit_request.version = this.version;
            return this;
        },
        
        version : "3.0",
        
        shorten : function( long_url, callback ) {
            var params = extend( {}, this.bit_request, { 'longUrl' : long_url } );
            this.apiRequest({
                'url' : host + urls.shorten,
                'data' : params,
                success : callback
            });           
        },
        
        lookup : function( long_url, callback ) {
            var params = extend( {}, this.bit_request, { 'url' : long_url } );
            this.apiRequest({
                'url' : host + urls.lookup,
                'data' : params,
                success : callback
            });
        },
        
        clicks : function( short_urls, callback ) {
            var params = extend( {}, this.bit_request, { 'shortUrl' : short_urls } );
            this.apiRequest({
                'url' : host + urls.clicks,
                'data' : params,
                success : callback
            });            
        },
        
        expand : function( short_urls, callback ) {
            var params = extend( {}, this.bit_request, { 'shortUrl' : short_urls } );
            this.apiRequest({
                'url' : host + urls.expand,
                'data' : params,
                success : callback
            });            
        },
        

        
        apiRequest : function( obj ) {
            /*
                obj = {
                    url : "http://url.com"
                    data : { "foo": "bar", "foo1" : ["bar", "bar1"] } etc
                    succees = function( json_response ) {  if(jo.status_code===200) { doSomething(jo.data); }  }
                }
            */
            var anon_func_name = "__bitlyApi" + ((new Date()).getTime() + Math.round(Math.random()*100000)), 
                jsonp_params = extend({}, obj.data, { 'callback' : anon_func_name }),
                time_out, script;

            window[anon_func_name] = function(jo){ 
                obj.success( jo );
                if(time_out) clearTimeout(time_out);
                script.parentNode.removeChild(script);
                delete window[anon_func_name]                
            }
            script = makeScript( obj.url + "?" + buildparams(jsonp_params) );
            time_out = setTimeout(function() {
                // try and remove the script element
                script.parentNode.removeChild(script);
                obj.success({'error' : 'timeout value exceeded'})                
            }, (obj.timeout || 6000) );
            //console.log(script)
        },
        
        bit_request : {
            login : null,
            apiKey : null,
            domain : "bit.ly",
            format : 'json'
        }
    }
    bitlyAPI.fn.init.prototype = bitlyAPI.fn;    
    
    
    function jsonp( obj ) {
        //var s = _mke("script");
        //var params = copy_obj( obj.data );
    }
    
    function internal_multiget() {
        // do not ask bit.ly for more than 15 at once -- be nice, play friendly
    }
    
    function buildparams( obj ) {
        // todo, handle errors / types better
        var params = [], a, k, i=0;
        for( k in obj ) {
            if(typeof obj[k] === "string") {
                // check has own property
                params[params.length] = k + "=" +encodeURIComponent( obj[k] );
            } else if(obj[k] && obj[k].length > 0 && typeof obj[k] === "object") {
                // could be an object or an array
                a = obj[k];
                for( i=0; i<a.length; i++) {
                    params[params.length] = k + "=" + encodeURIComponent(a[i]);                    
                }
            }
        }
        return params.join("&");
    }
    
    // similar to jQuery extend, doesn't support 'deep' copy, 0 error handling for functions
    function extend() {
        var target = arguments[0] || {}, length = arguments.length, i=0, options, name, src, copy;
        for( ; i<length; i++) {
            if( (options = arguments[i] ) !== null) {
                for(name in options) {
                    copy = options[ name ];
                    if( target === copy ) { continue; }
                    if(copy !== undefined ) {
                        target[name] = copy;
                    }
                }
            }
        }

        return target;
    }
    
    function makeScript( url_src ) {
        var s = _mke("script"), h = _get("head")[0] || document.documentElement;
        s.setAttribute('language','javascript'); 
        s.setAttribute('type', 'text/javascript');
        s.setAttribute('src',url_src);
        
        return h.appendChild( s );
        

    }
    function _get( elem_name ) {
        return document.getElementsByTagName( elem_name );
    }
    
    function _mke( name ) {
        return document.createElement( name );
    }
    
    function chunk(array, chunkSize) {
       var base = [], i, size = chunkSize || 5;
       for(i=0; i<array.length; i+=chunkSize ) { base.push( array.slice( i, i+chunkSize ) ); }	
       return base;
    }    
    
})();