(function(){
    
    var bitly, bitlyButton = function( login, apiKey ) {
        return new BitButton( login, apiKey );
    }
    window.bitlyButton=bitlyButton;
    function BitButton( login, apiKey ) {
        return this.init(login, apiKey)
    }
    
    BitButton.prototype = {
        init : function( login, apiKey ) {
            this.params.login = login;
            this.params.apiKey = apiKey;
            
            return this;
        },
        shorten : function( long_url, callback ) {
            var params = extend( {}, this.params, { 'longUrl' : long_url } );
            this.apiRequest({
                'url' : "http://api.bit.ly/v3/shorten",
                'data' : params,
                success : callback
            });           
        },
        
        apiRequest : function( obj ) {
            /*
                obj = {
                    url : "http://url.com"
                    data : { "foo": "bar", "foo1" : ["bar", "bar1"] } etc
                    succees = function( json_response ) {  if(jo.status_code===200) { doSomething(jo.data); }  }
                }
            */
            var anon_func_name = "__bitlyApi" + ((new Date()).getTime() + Math.round(Math.random()*100000)), 
                jsonp_params = extend({}, obj.data, { 'callback' : anon_func_name }),
                time_out, script;

            window[anon_func_name] = function(jo){ 
                obj.success( jo );
                if(time_out) clearTimeout(time_out);
                script.parentNode.removeChild(script);
                delete window[anon_func_name]                
            }
            script = makeScript( obj.url + "?" + buildparams(jsonp_params) );
            time_out = setTimeout(function() {
                // try and remove the script element
                script.parentNode.removeChild(script);
                obj.success({'error' : 'timeout value exceeded'})                
            }, (obj.timeout || 6000) );
        },      
        
        
        
        params : {
            login : "",
            format : "json",
            apiKey : ""
        }
    }
    
    function extend() {
        var target = arguments[0] || {}, length = arguments.length, i=0, options, name, copy;
        for( ; i<length; i++) {
            if( (options = arguments[i] ) !== null) {
                for(name in options) {
                    copy = options[ name ];
                    if( target === copy ) { continue; }
                    if(copy !== undefined ) {
                        target[name] = copy;
                    }
                }
            }
        }
        return target;
    }    
    
    function makeScript( url_src ) {
        var s = _mke("script"), h = _get("head")[0] || document.documentElement;
        s.setAttribute('language','javascript'); 
        s.setAttribute('type', 'text/javascript');
        s.setAttribute('src',url_src);
        return h.appendChild( s );
    }
    function _get( elem_name ) {
        return document.getElementsByTagName( elem_name );
    }
    
    function _mke( name ) {
        return document.createElement( name );
    }        
    
    function loaded(){  
        // look for link
        var doc_links=_get("a"), link, i=0, href, found_links=0, twitter_links=[], bit_link,
            page_url,j=0;
        // find the param
        // on this element
        for(; link=doc_links[i]; i++) {
            href = link.getAttribute("href")
            if(href) {
                if( href.indexOf('http://twitter.com/share') > -1 ) {

                    bit_link = link.getAttribute("bitly-url");
                    if(bit_link) {
                        link.setAttribute("data-url", bit_link);
                    } else {
                        found_links+=1;
                        twitter_links.push( link );                        
                    }

                }
            }
        }

        var counter = twitter_links.length;
        for(j=0; j<twitter_links.length; j++) {
            // get the right url to use...
            var long_url = find_url_of_choice( twitter_links[j] ), curr_el = twitter_links[j];

            (function( el, l_url ) {
                // if l_url was looked up already, cache
                bitly.shorten( l_url, function(jo) {                    
                    counter-=1;                        
                    // update the href with the url=sUrl, replace what's there or add it...
                    if(jo && jo.data && jo.status_code === 200 ) {  
                        el.setAttribute("data-url", jo.data.url );
                        el.setAttribute("data-counturl", l_url ); 
                    }
                    if(counter===0 && found_links > 0 ) {
                        loadTwitterScript();
                    }                        
                    
                    
                 }); 
            })( curr_el, long_url ); 
             
        }
         
    }
    function buildparams( obj ) {
        // todo, handle errors / types better
        var params = [], a, i;
        for(var k in obj ) {  
            if(obj[k] && obj[k].length > 0 && typeof obj[k] === "object") {
                a = obj[k];
                for(i=0; i<a.length; i++) { params[params.length] = k + "=" + encodeURIComponent(a[i]);  }
            } else if( obj[k] ){
                params[params.length] = k + "=" +encodeURIComponent( obj[k] );
            }

        }
        return params.join("&");
    }    
    
    function find_url_of_choice( elem ) {

        var page_url, j=0, href = elem.getAttribute("href"), q_string, params, canonicals, canonical;
        
        q_string = href.split("?").pop();
        params = q_string.split("&")
        for(j=0; j<params.length;j++) {
            if(params[j].indexOf("url=") === 0) {
                page_url = params[j].split("=").pop();
                break;
            }
        }        
        
        if(!page_url) {
            page_url = elem.getAttribute("data-url")
        }        
        
        if(!page_url) {
            canonicals = _get("link")
            for(j=0;canonical=canonicals[j]; j++) {
                if( canonical.getAttribute("rel") === "canonical") {
                    page_url = canonical.getAttribute("href");
                }
            }
        }        
        if(!page_url) {
            page_url = document.location.href;
        }
        // sort here?
        // don't strip utm though, be nice to publshers  

        return page_url;      
    }
    
    function loadTwitterScript() {
        makeScript("http://platform.twitter.com/widgets.js");        
    }
    
    // we'll just got aheand and callthis now...
    // remove if other behavior desired
    // add flag to comment out...
    function init( login, apiKey  ) {
        bitly = bitlyButton( login, apiKey );

        if ( document.addEventListener ) {
            document.addEventListener("DOMContentLoaded", loaded, false);

        } else if ( window.attachEvent ) {
            window.attachEvent("onload", loaded);
        }

        
    }
    
    
    var LOGIN = "exttestaccount",
        YOUR_API_KEY = "R_0d3f58015f6030b3183d9fbce2f4723b"    
    init( LOGIN, YOUR_API_KEY );
    
    // alternative would be to not call this init, and instead do other stuff...
    
})();